#module for reading the inputs for mNiBLoS from terminal
#almost no checking for correctness is done (the input are expected to be in the proper format)


import sys
import Data


def read():
	logicFormattingHelp = """The logics accepted by mNiBLoS have two main possible formats:
  		* bl  (to indicate Hajek's Basic Logic)
    		* (b1, t1)v1+(b2,t2)v2+...+(bn, tn)vn (to indicate the ordinal sum of the logics vi in the intervals (tk, t(k+1)) where:
        		- bi,ti are rational values in [0,1] with bi < ti, and ti <= b(i+1)
        		- vi are of the following form:
             			l (for denoting a Lukasiewicz component)
             			ln with n natural number >= 2 (for denoting an n-valued Lukasiewicz component)
             			g (for denoting a Godel component)
             			gn with n natural number >= 2 (for denoting an n-valued Godel component)
             			p (for denoting a Product component)
	"""
	formulaFormattingHelp = """The format of the formuli accepted  by mNiBLoS is as follows:
  		1) The variables must be named by xi, where i are natural numbers
		2) The constants can be either rational numbers in (0,1)
		3) The formulas are built inductively from variables and constant symbols as follows:
			*The notation must be polish (prefix) and in parenthesis, i.e., (operation arg1 ... argn) for an n-ary operation and argi valid formulas
			* The possible operations with their corresponding arity and usual meaning is the following:
				- wcon/2 (weak conjunction/minimum)
				- wdis/2 (weak disjunction/maximum)
				- con/2 (conjuntion/t-norm)
				- impl/2 (implication/residuum)
				- neg/1 (negation/(impl x 0))
				- delta/1 (Monteiro-Baaz Delta)
				- box/1 (modal box operation)
				- diamond/1 (modal diamond operation)
The equations (for the satisfiability operation) must be of the form (R form1 form2), where
        	* form1 and form2 are formulas in the previous format
            * R is a relation operation among the following ones:
            	- eq (equal)
                - leq (less or equal)
                - l (strictly less)
                - ge (greater or equal)
                - g (strictly greater)
	"""

	loop = 0
	while loop == 0:
		inpGen = raw_input("Specify the BL-logic for basic reasoning: (for help on the format, write 'h') ")
		if inpGen == "h":
			print logicFormattingHelp
		else :
			loop = 1
			rawLogic = inpGen
	#possibility of defining some characteristics for the model?
	
	#operation to be executed and data related to that
	
	operation = raw_input("Select the operation: theoremhood proving (th), deduction proving (d), equations satisfiability (s): ")
	
	formatHelp = raw_input("If you need help on the formatting of the formulas/equations, wite 'h'. Otherwise, press any other key...")
	if formatHelp == "h":
		print formulaFormattingHelp
	if operation == "th":
		#dataOperation  will be a formula
		#help para el formato de las ecucaciones!!
		dataOperation = [raw_input("Write the formula:")]
	elif operation == "d":
		#dataOperation  will be a list of formulas, the last of which is
		#the consequence of the deduction (with possibly rational numbers (constants))
		dataOperation = []
		p = 0
		while p == 0:
			dataOperation.append(raw_input("Write one of the premises: "))
			if raw_input("more premises? (y/n) ") == "n":
				p = 1
		dataOperation.append(raw_input("Write the consequence formula:"))
    
	elif operation == "s":
		#dataOperation  will be a list of equations, with possibly rational numbers (constants)
		#help para el formato de las ecuaciones!!
		dataOperation = []
		p = 0
		while p == 0:
			dataOperation.append(raw_input("Write one of the equations: "))
			if raw_input("more equations? (y/n) ") == "n":
				p = 1

	return Data.RawData(rawLogic, operation, dataOperation)
	
	
	